Index: cpp/frams/_demos/f0_variants_test.cpp
===================================================================
--- cpp/frams/_demos/f0_variants_test.cpp	(revision 372)
+++ cpp/frams/_demos/f0_variants_test.cpp	(revision 375)
@@ -10,5 +10,5 @@
 #include <frams/genetics/defgenoconv.h>
 #include <frams/model/model.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 void save_as_f0(SString &gen,Model &m,bool omit_default_values)
@@ -74,5 +74,5 @@
 int main(int argc,char*argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 
 //without converters the application would only handle "format 0" genotypes
Index: cpp/frams/_demos/full_props.cpp
===================================================================
--- cpp/frams/_demos/full_props.cpp	(revision 372)
+++ cpp/frams/_demos/full_props.cpp	(revision 375)
@@ -9,5 +9,5 @@
 
 #include <frams/model/model.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 #include <frams/genetics/preconfigured.h>
 
@@ -50,5 +50,5 @@
 {
 StdioFILE::setStdio();//setup VirtFILE::Vstdin/out/err
-MessageHandlerToStdout messages_to_stderr(MessageHandlerBase::Enable | MessageHandlerBase::DontBlock,VirtFILE::Vstderr); //errors -> stderr, don't interfere with stdout
+LoggerToStdout messages_to_stderr(LoggerBase::Enable | LoggerBase::DontBlock,VirtFILE::Vstderr); //errors -> stderr, don't interfere with stdout
 
 PreconfiguredGenetics genetics;
@@ -79,5 +79,5 @@
 if (!m.isValid())
 	{
-	Hprintf("","full_props",HMLV_ERROR,"Cannot build Model from the supplied genotype\n");
+	logPrintf("","full_props",LOG_ERROR,"Cannot build Model from the supplied genotype\n");
 	return 2;	
 	}
Index: cpp/frams/_demos/geno_test.cpp
===================================================================
--- cpp/frams/_demos/geno_test.cpp	(revision 372)
+++ cpp/frams/_demos/geno_test.cpp	(revision 375)
@@ -6,5 +6,5 @@
 #include <frams/util/sstringutils.h>
 #include <frams/genetics/preconfigured.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 /**
@@ -18,5 +18,5 @@
 {
 	PreconfiguredGenetics genetics;
-	MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable); //comment this object out to mute error/warning messages
+	LoggerToStdout messages_to_stdout(LoggerBase::Enable); //comment this object out to mute error/warning messages
 
 	if (argc <= 1)
Index: cpp/frams/_demos/genoconv_test.cpp
===================================================================
--- cpp/frams/_demos/genoconv_test.cpp	(revision 372)
+++ cpp/frams/_demos/genoconv_test.cpp	(revision 375)
@@ -9,5 +9,5 @@
 
 #include "printconvmap.h"
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 /**
@@ -117,5 +117,5 @@
 int main(int argc,char *argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 
 DefaultGenoConvManager gcm;
Index: cpp/frams/_demos/genomanipulation.cpp
===================================================================
--- cpp/frams/_demos/genomanipulation.cpp	(revision 372)
+++ cpp/frams/_demos/genomanipulation.cpp	(revision 375)
@@ -10,5 +10,5 @@
 #include <frams/model/model.h>
 #include <frams/genetics/preconfigured.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 /**
@@ -266,5 +266,5 @@
 int main(int argc,char*argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable); //redirect model-related errors to stdout
+LoggerToStdout messages_to_stdout(LoggerBase::Enable); //redirect model-related errors to stdout
 
 srand(time(0));
Index: cpp/frams/_demos/genooper_test.cpp
===================================================================
--- cpp/frams/_demos/genooper_test.cpp	(revision 372)
+++ cpp/frams/_demos/genooper_test.cpp	(revision 375)
@@ -3,5 +3,5 @@
 // See LICENSE.txt for details.
 
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 #include <frams/genetics/preconfigured.h>
 
@@ -21,5 +21,5 @@
 int main(int argc, char *argv[])
 {
-	MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+	LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 	PreconfiguredGenetics genetics;
 
Index: cpp/frams/_demos/loader_test_param.cpp
===================================================================
--- cpp/frams/_demos/loader_test_param.cpp	(revision 372)
+++ cpp/frams/_demos/loader_test_param.cpp	(revision 375)
@@ -5,5 +5,5 @@
 #include <frams/param/multiparamload.h>
 #include <frams/virtfile/stdiofile.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 /**
@@ -66,5 +66,5 @@
 	StdioFILEDontClose virt_stderr(stderr);
 	StdioFILEDontClose virt_stdout(stdout);
-	MessageHandlerToStdout messages_to_stderr(MessageHandlerBase::Enable, &virt_stderr);
+	LoggerToStdout messages_to_stderr(LoggerBase::Enable, &virt_stderr);
 	StdioFileSystem_autoselect stdiofilesys;
 	MultiParamLoader loader(argv[1]);
Index: cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- cpp/frams/_demos/multiline_f0_test.cpp	(revision 372)
+++ cpp/frams/_demos/multiline_f0_test.cpp	(revision 375)
@@ -10,10 +10,10 @@
 #include <frams/genetics/preconfigured.h>
 #include <frams/model/model.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 #include <frams/virtfile/stringfile.h>
 
 int main(int argc,char*argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 PreconfiguredGenetics genetics;
 
Index: cpp/frams/_demos/neuro_layout_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_layout_test.cpp	(revision 372)
+++ cpp/frams/_demos/neuro_layout_test.cpp	(revision 375)
@@ -7,5 +7,5 @@
 #include <frams/genetics/preconfigured.h>
 #include <frams/model/model.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 #include <frams/canvas/nn_layout_model.h>
 
@@ -83,5 +83,5 @@
 int main(int argc,char*argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 PreconfiguredGenetics genetics;
 
Index: cpp/frams/_demos/neuro_test.cpp
===================================================================
--- cpp/frams/_demos/neuro_test.cpp	(revision 372)
+++ cpp/frams/_demos/neuro_test.cpp	(revision 375)
@@ -9,5 +9,5 @@
 #include <frams/neuro/neuroimpl.h>
 #include <frams/neuro/neurofactory.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 
 /**
@@ -60,5 +60,5 @@
 int main(int argc,char*argv[])
 {
-MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+LoggerToStdout messages_to_stdout(LoggerBase::Enable);
 PreconfiguredGenetics genetics;
 
Index: cpp/frams/_demos/shapeconvert.cpp
===================================================================
--- cpp/frams/_demos/shapeconvert.cpp	(revision 372)
+++ cpp/frams/_demos/shapeconvert.cpp	(revision 375)
@@ -9,5 +9,5 @@
 
 #include <frams/model/model.h>
-#include <frams/mhandlers/stdouthandler.h>
+#include <frams/loggers/loggertostdout.h>
 #include <frams/genetics/preconfigured.h>
 
@@ -34,5 +34,5 @@
 {
 	StdioFILE::setStdio();//setup VirtFILE::Vstdin/out/err
-	MessageHandlerToStdout messages_to_stderr(MessageHandlerBase::Enable | MessageHandlerBase::DontBlock, VirtFILE::Vstderr); //errors -> stderr, don't interfere with stdout
+	LoggerToStdout messages_to_stderr(LoggerBase::Enable | LoggerBase::DontBlock, VirtFILE::Vstderr); //errors -> stderr, don't interfere with stdout
 
 	PreconfiguredGenetics genetics;
@@ -50,5 +50,5 @@
 				if ((shape != Part::SHAPE_ELLIPSOID) && (shape != Part::SHAPE_CUBOID) && (shape != Part::SHAPE_CYLINDER))
 				{
-					Hprintf("", "shapeconvert", HMLV_ERROR, "Invalid shape");
+					logPrintf("", "shapeconvert", LOG_ERROR, "Invalid shape");
 					return 4;
 				}
@@ -71,5 +71,5 @@
 	if (!m.isValid())
 	{
-		Hprintf("", "shapeconvert", HMLV_ERROR, "Cannot build Model from the supplied genotype");
+		logPrintf("", "shapeconvert", LOG_ERROR, "Cannot build Model from the supplied genotype");
 		return 2;
 	}
@@ -77,5 +77,5 @@
 	if (m.getShape() != Model::SHAPE_OLD)
 	{
-		Hprintf("", "shapeconvert", HMLV_ERROR, "Only old style shapes can be converted");
+		logPrintf("", "shapeconvert", LOG_ERROR, "Only old style shapes can be converted");
 		return 3;
 	}
Index: cpp/frams/_demos/simil_test.cpp
===================================================================
--- cpp/frams/_demos/simil_test.cpp	(revision 372)
+++ cpp/frams/_demos/simil_test.cpp	(revision 375)
@@ -5,5 +5,5 @@
 
 #include <vector>
-#include "frams/mhandlers/stdouthandler.h"
+#include "frams/loggers/loggertostdout.h"
 #include "frams/_demos/genotypeloader.h"
 #include "frams/genetics/preconfigured.h"
@@ -39,5 +39,5 @@
 int main(int argc, char *argv[])
 {
-    MessageHandlerToStdout messages_to_stdout(MessageHandlerBase::Enable);
+    LoggerToStdout messages_to_stdout(LoggerBase::Enable);
     typedef double *pDouble;
     int iCurrParam = 0; // index of the currently processed parameter