Index: experiments/frams/foraminifera/data/scripts/foraminifera.expdef
===================================================================
--- experiments/frams/foraminifera/data/scripts/foraminifera.expdef	(revision 422)
+++ experiments/frams/foraminifera/data/scripts/foraminifera.expdef	(revision 423)
@@ -557,5 +557,5 @@
 prop:
 id:e_repro_cost_haplo
-name:cost of reproduction
+name:Cost of reproduction
 type:f 0.1 0.9 0.5
 group:Foraminifera
@@ -563,5 +563,5 @@
 prop:
 id:e_repro_cost_diplo
-name:cost of reproduction
+name:Cost of reproduction
 type:f 0.1 0.9 0.3
 group:Foraminifera
@@ -569,5 +569,5 @@
 prop:
 id:chamber_proculus_haplo
-name:size of proculus
+name:Size of proculus
 type:f
 group:Foraminifera
@@ -575,5 +575,5 @@
 prop:
 id:chamber_proculus_diplo
-name:size of proculus
+name:Size of proculus
 type:f
 group:Foraminifera
@@ -581,5 +581,5 @@
 prop:
 id:chamber_difference_haplo
-name:difference in size between subsequent chambers
+name:Difference in size between subsequent chambers
 type:f
 group:Foraminifera
@@ -587,5 +587,5 @@
 prop:
 id:chamber_difference_diplo
-name:difference in size between subsequent chambers
+name:Difference in size between subsequent chambers
 type:f
 group:Foraminifera
@@ -689,6 +689,6 @@
 prop:
 id:e_death_level
-name:Level of energy ... death
-type:f 0
+name:Minimal level of energy to sustain life
+type:f 0 20 0
 group:Foraminifera
 
@@ -723,5 +723,5 @@
 id:nutrientsize
 name:Nutrients's size
-type:f 0.1
+type:f 0.1 0.9 0.1
 group:Energy
 
Index: experiments/frams/foraminifera/data/scripts/foraminifera.show
===================================================================
--- experiments/frams/foraminifera/data/scripts/foraminifera.show	(revision 422)
+++ experiments/frams/foraminifera/data/scripts/foraminifera.show	(revision 423)
@@ -13,4 +13,6 @@
 code:~
 
+global Params;
+
 function onLoad()
 {
@@ -18,80 +20,36 @@
 	GLDisplay.desiredsimspeed = 50;
 	GLDisplay.minfps = 10;
+
+	Params = {"nutrientPop" : [5,10,15], "feedrate" : [0.001,0.0025,0.004], "feedtrans" : [0.01,0.05,0.1],"energy_nut" :[0.5,1.5,3.0], "stress" : [0,1]};
 }
+
+function setShowParam(param_id)
+{
+	ExpParams.[param_id] = Params[param_id][ShowParams.[param_id]];
+}
+
 function ShowParams_nutrientPop_set()
 {
-	switch (ShowParams.nutrientPop)
-	{
-	case 0:
-		ExpParams.nutrientPop = 5;
-		break;
-	case 1:
-		ExpParams.nutrientPop = 10;
-		break;
-	case 2:
-		ExpParams.nutrientPop = 15;
-		break;
-	}
+	setShowParam("nutrientPop");
 }
 
-function ShowParams_feedRate_set()
+function ShowParams_feedrate_set()
 {
-	switch (ShowParams.feedRate)
-	{
-	case 0:
-		ExpParams.feedrate = 0.001;
-		break;
-	case 1:
-		ExpParams.feedrate = 0.0025;
-		break;
-	case 2:
-		ExpParams.feedrate = 0.004;
-		break;
-	}
+	setShowParam("feedrate");
 }
 
-function ShowParams_feedTrans_set()
+function ShowParams_feedtrans_set()
 {
-	switch (ShowParams.feedTrans)
-	{
-	case 0:
-		ExpParams.feedtrans = 0.01;
-		break;
-	case 1:
-		ExpParams.feedtrans = 0.05;
-		break;
-	case 2:
-		ExpParams.feedtrans = 0.1;
-		break;
-	}
+	setShowParam("feedtrans");
 }
 
-function ShowParams_nutrientEnerg_set()
+function ShowParams_energy_nut_set()
 {
-	switch (ShowParams.nutrientEnerg)
-	{
-	case 0:
-		ExpParams.energy_nut = 0.5;
-		break;
-	case 1:
-		ExpParams.energy_nut = 1.5;
-		break;
-	case 2:
-		ExpParams.energy_nut = 3.0;
-		break;
-	}
+	setShowParam("energy_nut");
 }
 
 function ShowParams_stress_set()
 {
-	switch (ShowParams.stress)
-	{
-	case 0:
-		ExpParams.stress = 0;
-		break;
-	case 1:
-		ExpParams.stress = 1;
-		break;
-	}
+	setShowParam("stress");
 }
 
@@ -104,15 +62,15 @@
 
 prop:
-id:feedRate
+id:feedrate
 name:Feeding rate
-type:d 0 2 1 ~1~2~3
+type:d 0 2 1 ~Low~Medium~High
 
 prop:
-id:feedTrans
+id:feedtrans
 name:Energy transfer
 type:d 0 2 1 ~0.01~0.05~0.1
 
 prop:
-id:nutrientEnerg
+id:energy_nut
 name:Nutrient energy
 type:d 0 2 1 ~0.5~1.5~3